#include "rigidbodytransformation.h"
#include "primitive.h"

RigidBodyTransformation::RigidBodyTransformation()
{
    translation = QVector3D(0,0,0);
    rotation = QQuaternion();
    name = "<rbt>";
//    qDebug() << "new rbt " << tx << "," << ty << "," << tz << ", rot " << rotation;
}

RigidBodyTransformation::~RigidBodyTransformation(){
//apparently I do not need to call the baseclass destructor.
}

//0 = name, 1 = translation, 2=rotation
QVariant RigidBodyTransformation::data(int column){
    if (column == 0) return QVariant(name);
    else if (column == 1) return QVariant(translation);
    else if (column == 2) return QVariant(rotation);
    else return QVariant();
}


void RigidBodyTransformation::addTranslation(QVector3D diff){
    translation += diff;
}

const QVector3D RigidBodyTransformation::getTranslation(){
    return translation;
}

const QQuaternion RigidBodyTransformation::getRotation(){
    return rotation;
}

void RigidBodyTransformation::addRotation(QQuaternion diff){
    rotation = diff*rotation;
    rotation.normalize();
}

void RigidBodyTransformation::setRotation(QQuaternion newRotation){
    rotation = newRotation;
}

Primitive* RigidBodyTransformation::getChildAsPrimitive(int row){
    if (row < children.length()){
        return static_cast<Primitive*>(children[row]);//TODO aufpassen falls höhere tiefe
    } else{
        qDebug() << "WAAAH - RBT has not enough chilren for row " << row;
    }
}
