#ifndef RIGIDBODYTRANSFORMATION_H
#define RIGIDBODYTRANSFORMATION_H

#include <QQuaternion>
#include <QDebug>
#include "treeitem.h"
class Primitive;

class RigidBodyTransformation : public TreeItem
{
public:
    RigidBodyTransformation();
    ~RigidBodyTransformation();

    void addTranslation(QVector3D diff);
    void setRotation(QQuaternion newRotation);
    void addRotation(QQuaternion diff);

    const QQuaternion getRotation();
    const QVector3D getTranslation();

    QVariant data(int column) override;

    Primitive* getChildAsPrimitive(int row);

private :
    //translation
    QVector3D translation;
    //rotation
    QQuaternion rotation;

    //child in scene graph
    Primitive* childPrimitive;
};

#endif // RIGIDBODYTRANSFORMATION_H
