#include "treeitem.h"

TreeItem::TreeItem()
{
    children = QList<TreeItem*>();
    name = "root";
}

TreeItem::~TreeItem(){
    while(children.length() > 0){
        TreeItem* t = children[0];
        children.removeAt(0);
        t->~TreeItem();
    }
}

void TreeItem::setName(QString newName){
    name = newName;
    qDebug() << "Name set to "  << name;
}

QString TreeItem::getName(){
    return name;
}

void TreeItem::setParent(TreeItem *parent){
    this->parent = parent;
}

TreeItem* TreeItem::getParent(){
    return parent;
}

int TreeItem::getChildrenCount(){
    return children.length();
}

//adds to child list before [index] AND sets itself as parent.
void TreeItem::addChild(TreeItem *item, int index){
    if (index >= children.length()){
        children.append(item);
    }else{
        children.insert(index,item);
    }
    item->setParent(this);
}

//removes from children list. Does NOT delet child.
bool TreeItem::removeChild(TreeItem *item){
    return children.removeOne(item);
}

QList<TreeItem*> TreeItem::getChildren(){
    return children;
}

TreeItem* TreeItem::getChild(int index){
    if (index < children.length()){
        return children[index];
    }
    return 0;
}

int TreeItem::columnCount(){
    return 1;
}

QVariant TreeItem::data(int column){
    if (column == 0) return QVariant(name);
    else return QVariant("ERROR column index");
}


//OWN index.
int TreeItem::childNumber(){
    if (parent){
        return parent->getChildren().indexOf(this);
    }
    return 0; //for root.
}
